# coding: utf-8

"""
    Compliance Rule

    Compliance Rules are used to automatically monitor whether a fund adheres to a regulation, client mandate, or internal guideline.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr
from asdk_plugin_compliance.agraph.compliance.state.compliance_rule.v1.ComplianceRuleAPI.models.enums_compliance_severity import EnumsComplianceSeverity
from asdk_plugin_compliance.agraph.compliance.state.compliance_rule.v1.ComplianceRuleAPI.models.v1_disaggregate_positions import V1DisaggregatePositions
from asdk_plugin_compliance.agraph.compliance.state.compliance_rule.v1.ComplianceRuleAPI.models.v1_run_active_compliance_type import V1RunActiveComplianceType

class V1ScriptedRule(BaseModel):
    """
    ScriptedRule Rule type.
    """
    script: StrictStr = Field(...)
    rule_look_through: Optional[StrictStr] = Field(None, alias="ruleLookThrough", description="The field indicating how look-through will be applied during the rule's evaluation.")
    run_active_compliance_type: Optional[V1RunActiveComplianceType] = Field(None, alias="runActiveComplianceType")
    run_overnight: Optional[StrictBool] = Field(None, alias="runOvernight", description="The rule's run_overnight field instructs the system that rule should be applied overnight.")
    run_intraday: Optional[StrictBool] = Field(None, alias="runIntraday", description="The rule's run_intraday field instructs the system that rule should be applied intraday.")
    settled_positions_only: Optional[StrictBool] = Field(None, alias="settledPositionsOnly", description="A Boolean flag to remove positions that have yet to settle from rule evaluation on an overnight basis.")
    include_non_investment_position: Optional[StrictBool] = Field(None, alias="includeNonInvestmentPosition", description="A Boolean flag to include non-investment positions such as collateral and security lending positions.")
    split_fx_leg: Optional[StrictBool] = Field(None, alias="splitFxLeg", description="A Boolean flag indicating that split FX, the splitting of securities into their respective pay and receive legs, has been enabled.")
    disaggregate_positions: Optional[V1DisaggregatePositions] = Field(None, alias="disaggregatePositions")
    disable_passive_violation: Optional[StrictBool] = Field(None, alias="disablePassiveViolation")
    disable_directionality: Optional[StrictBool] = Field(None, alias="disableDirectionality")
    severity: Optional[EnumsComplianceSeverity] = None
    __properties = ["script", "ruleLookThrough", "runActiveComplianceType", "runOvernight", "runIntraday", "settledPositionsOnly", "includeNonInvestmentPosition", "splitFxLeg", "disaggregatePositions", "disablePassiveViolation", "disableDirectionality", "severity"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1ScriptedRule:
        """Create an instance of V1ScriptedRule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1ScriptedRule:
        """Create an instance of V1ScriptedRule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1ScriptedRule.parse_obj(obj)

        _obj = V1ScriptedRule.parse_obj({
            "script": obj.get("script"),
            "rule_look_through": obj.get("ruleLookThrough"),
            "run_active_compliance_type": obj.get("runActiveComplianceType"),
            "run_overnight": obj.get("runOvernight"),
            "run_intraday": obj.get("runIntraday"),
            "settled_positions_only": obj.get("settledPositionsOnly"),
            "include_non_investment_position": obj.get("includeNonInvestmentPosition"),
            "split_fx_leg": obj.get("splitFxLeg"),
            "disaggregate_positions": obj.get("disaggregatePositions"),
            "disable_passive_violation": obj.get("disablePassiveViolation"),
            "disable_directionality": obj.get("disableDirectionality"),
            "severity": obj.get("severity")
        })
        return _obj

