# coding: utf-8

"""
    Compliance Rule Assignment

    Rule assignment assigns compliance rules for portfolio.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import re  # noqa: F401
import io
import warnings

from pydantic import validate_arguments, ValidationError
from typing_extensions import Annotated

from datetime import datetime

from pydantic import Field, StrictStr

from typing import Optional

from asdk_plugin_compliance.agraph.compliance.state.compliance_rule_assignment.v1.ComplianceRuleAssignmentAPI.models.v1_compliance_rule_assignment import V1ComplianceRuleAssignment
from asdk_plugin_compliance.agraph.compliance.state.compliance_rule_assignment.v1.ComplianceRuleAssignmentAPI.models.v1_filter_compliance_rule_assignments_request import V1FilterComplianceRuleAssignmentsRequest
from asdk_plugin_compliance.agraph.compliance.state.compliance_rule_assignment.v1.ComplianceRuleAssignmentAPI.models.v1_filter_compliance_rule_assignments_response import V1FilterComplianceRuleAssignmentsResponse

from asdk_plugin_compliance.agraph.compliance.state.compliance_rule_assignment.v1.ComplianceRuleAssignmentAPI.api_client import ApiClient
from asdk_plugin_compliance.agraph.compliance.state.compliance_rule_assignment.v1.ComplianceRuleAssignmentAPI.api_response import ApiResponse
from asdk_plugin_compliance.agraph.compliance.state.compliance_rule_assignment.v1.ComplianceRuleAssignmentAPI.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class DefaultComplianceRuleAssignmentAPI(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_arguments
    def compliance_rule_assignment_api_create_compliance_rule_assignment(self, vnd_com_blackrock_request_id : Annotated[StrictStr, Field(..., description="A unique identifier for this request.")], vnd_com_blackrock_origin_timestamp : Annotated[datetime, Field(..., description="Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231.")], body : Annotated[V1ComplianceRuleAssignment, Field(..., description="ComplianceRuleAssignment to create.")], **kwargs) -> V1ComplianceRuleAssignment:  # noqa: E501
        """Creates a new Rule Assignment  # noqa: E501

        This is responsible for creating a new Rule Assignment Record. (-- api-linter: core::0133::http-uri-parent=disabled  aip.dev/not-precedent: We need to do this because complianceRuleAssignments is the parent collection --)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.compliance_rule_assignment_api_create_compliance_rule_assignment(vnd_com_blackrock_request_id, vnd_com_blackrock_origin_timestamp, body, async_req=True)
        >>> result = thread.get()

        :param vnd_com_blackrock_request_id: A unique identifier for this request. (required)
        :type vnd_com_blackrock_request_id: str
        :param vnd_com_blackrock_origin_timestamp: Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231. (required)
        :type vnd_com_blackrock_origin_timestamp: datetime
        :param body: ComplianceRuleAssignment to create. (required)
        :type body: V1ComplianceRuleAssignment
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: V1ComplianceRuleAssignment
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the compliance_rule_assignment_api_create_compliance_rule_assignment_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.compliance_rule_assignment_api_create_compliance_rule_assignment_with_http_info(vnd_com_blackrock_request_id, vnd_com_blackrock_origin_timestamp, body, **kwargs)  # noqa: E501

    @validate_arguments
    def compliance_rule_assignment_api_create_compliance_rule_assignment_with_http_info(self, vnd_com_blackrock_request_id : Annotated[StrictStr, Field(..., description="A unique identifier for this request.")], vnd_com_blackrock_origin_timestamp : Annotated[datetime, Field(..., description="Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231.")], body : Annotated[V1ComplianceRuleAssignment, Field(..., description="ComplianceRuleAssignment to create.")], **kwargs) -> ApiResponse:  # noqa: E501
        """Creates a new Rule Assignment  # noqa: E501

        This is responsible for creating a new Rule Assignment Record. (-- api-linter: core::0133::http-uri-parent=disabled  aip.dev/not-precedent: We need to do this because complianceRuleAssignments is the parent collection --)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.compliance_rule_assignment_api_create_compliance_rule_assignment_with_http_info(vnd_com_blackrock_request_id, vnd_com_blackrock_origin_timestamp, body, async_req=True)
        >>> result = thread.get()

        :param vnd_com_blackrock_request_id: A unique identifier for this request. (required)
        :type vnd_com_blackrock_request_id: str
        :param vnd_com_blackrock_origin_timestamp: Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231. (required)
        :type vnd_com_blackrock_origin_timestamp: datetime
        :param body: ComplianceRuleAssignment to create. (required)
        :type body: V1ComplianceRuleAssignment
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(V1ComplianceRuleAssignment, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'vnd_com_blackrock_request_id',
            'vnd_com_blackrock_origin_timestamp',
            'body'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method compliance_rule_assignment_api_create_compliance_rule_assignment" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['vnd_com_blackrock_request_id']:
            _header_params['VND.com.blackrock.Request-ID'] = _params['vnd_com_blackrock_request_id']

        if _params['vnd_com_blackrock_origin_timestamp']:
            _header_params['VND.com.blackrock.Origin-Timestamp'] = _params['vnd_com_blackrock_origin_timestamp']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['body'] is not None:
            _body_params = _params['body']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['APIKeyHeader', 'OAuth2ClientCredentials', 'basicAuth', 'OAuth2AccessCode', 'ClientKeyHeader']  # noqa: E501

        _response_types_map = {
            '200': "V1ComplianceRuleAssignment",
            '400': "ComplianceRuleAssignmentAPICreateComplianceRuleAssignment400Response",
            '401': "ComplianceRuleAssignmentAPICreateComplianceRuleAssignment400Response",
            '403': "ComplianceRuleAssignmentAPICreateComplianceRuleAssignment400Response",
            '404': "ComplianceRuleAssignmentAPICreateComplianceRuleAssignment400Response",
        }

        return self.api_client.call_api(
            '/complianceRuleAssignments', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def compliance_rule_assignment_api_filter_compliance_rule_assignments(self, vnd_com_blackrock_request_id : Annotated[StrictStr, Field(..., description="A unique identifier for this request.")], vnd_com_blackrock_origin_timestamp : Annotated[datetime, Field(..., description="Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231.")], body : V1FilterComplianceRuleAssignmentsRequest, **kwargs) -> V1FilterComplianceRuleAssignmentsResponse:  # noqa: E501
        """Filters ComplianceRuleAssignments  # noqa: E501

        Filters ComplianceRuleAssignments. If special character is provided as part of path parameter then it should be provided in url encoded form.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.compliance_rule_assignment_api_filter_compliance_rule_assignments(vnd_com_blackrock_request_id, vnd_com_blackrock_origin_timestamp, body, async_req=True)
        >>> result = thread.get()

        :param vnd_com_blackrock_request_id: A unique identifier for this request. (required)
        :type vnd_com_blackrock_request_id: str
        :param vnd_com_blackrock_origin_timestamp: Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231. (required)
        :type vnd_com_blackrock_origin_timestamp: datetime
        :param body: (required)
        :type body: V1FilterComplianceRuleAssignmentsRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: V1FilterComplianceRuleAssignmentsResponse
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the compliance_rule_assignment_api_filter_compliance_rule_assignments_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.compliance_rule_assignment_api_filter_compliance_rule_assignments_with_http_info(vnd_com_blackrock_request_id, vnd_com_blackrock_origin_timestamp, body, **kwargs)  # noqa: E501

    @validate_arguments
    def compliance_rule_assignment_api_filter_compliance_rule_assignments_with_http_info(self, vnd_com_blackrock_request_id : Annotated[StrictStr, Field(..., description="A unique identifier for this request.")], vnd_com_blackrock_origin_timestamp : Annotated[datetime, Field(..., description="Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231.")], body : V1FilterComplianceRuleAssignmentsRequest, **kwargs) -> ApiResponse:  # noqa: E501
        """Filters ComplianceRuleAssignments  # noqa: E501

        Filters ComplianceRuleAssignments. If special character is provided as part of path parameter then it should be provided in url encoded form.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.compliance_rule_assignment_api_filter_compliance_rule_assignments_with_http_info(vnd_com_blackrock_request_id, vnd_com_blackrock_origin_timestamp, body, async_req=True)
        >>> result = thread.get()

        :param vnd_com_blackrock_request_id: A unique identifier for this request. (required)
        :type vnd_com_blackrock_request_id: str
        :param vnd_com_blackrock_origin_timestamp: Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231. (required)
        :type vnd_com_blackrock_origin_timestamp: datetime
        :param body: (required)
        :type body: V1FilterComplianceRuleAssignmentsRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(V1FilterComplianceRuleAssignmentsResponse, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'vnd_com_blackrock_request_id',
            'vnd_com_blackrock_origin_timestamp',
            'body'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method compliance_rule_assignment_api_filter_compliance_rule_assignments" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['vnd_com_blackrock_request_id']:
            _header_params['VND.com.blackrock.Request-ID'] = _params['vnd_com_blackrock_request_id']

        if _params['vnd_com_blackrock_origin_timestamp']:
            _header_params['VND.com.blackrock.Origin-Timestamp'] = _params['vnd_com_blackrock_origin_timestamp']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['body'] is not None:
            _body_params = _params['body']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['APIKeyHeader', 'OAuth2ClientCredentials', 'basicAuth', 'OAuth2AccessCode', 'ClientKeyHeader']  # noqa: E501

        _response_types_map = {
            '200': "V1FilterComplianceRuleAssignmentsResponse",
            '400': "ComplianceRuleAssignmentAPICreateComplianceRuleAssignment400Response",
            '401': "ComplianceRuleAssignmentAPICreateComplianceRuleAssignment400Response",
            '403': "ComplianceRuleAssignmentAPICreateComplianceRuleAssignment400Response",
            '404': "ComplianceRuleAssignmentAPICreateComplianceRuleAssignment400Response",
        }

        return self.api_client.call_api(
            '/complianceRuleAssignments:filter', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def compliance_rule_assignment_api_get_compliance_rule_assignment(self, vnd_com_blackrock_request_id : Annotated[StrictStr, Field(..., description="A unique identifier for this request.")], vnd_com_blackrock_origin_timestamp : Annotated[datetime, Field(..., description="Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231.")], id : Annotated[StrictStr, Field(..., description="Compliance rule assignment id")], **kwargs) -> V1ComplianceRuleAssignment:  # noqa: E501
        """Gets a ComplianceRuleAssignment  # noqa: E501

        Gets a ComplianceRuleAssignment. If special character is provided as part of path parameter then it should be provided in url encoded form.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.compliance_rule_assignment_api_get_compliance_rule_assignment(vnd_com_blackrock_request_id, vnd_com_blackrock_origin_timestamp, id, async_req=True)
        >>> result = thread.get()

        :param vnd_com_blackrock_request_id: A unique identifier for this request. (required)
        :type vnd_com_blackrock_request_id: str
        :param vnd_com_blackrock_origin_timestamp: Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231. (required)
        :type vnd_com_blackrock_origin_timestamp: datetime
        :param id: Compliance rule assignment id (required)
        :type id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: V1ComplianceRuleAssignment
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the compliance_rule_assignment_api_get_compliance_rule_assignment_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.compliance_rule_assignment_api_get_compliance_rule_assignment_with_http_info(vnd_com_blackrock_request_id, vnd_com_blackrock_origin_timestamp, id, **kwargs)  # noqa: E501

    @validate_arguments
    def compliance_rule_assignment_api_get_compliance_rule_assignment_with_http_info(self, vnd_com_blackrock_request_id : Annotated[StrictStr, Field(..., description="A unique identifier for this request.")], vnd_com_blackrock_origin_timestamp : Annotated[datetime, Field(..., description="Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231.")], id : Annotated[StrictStr, Field(..., description="Compliance rule assignment id")], **kwargs) -> ApiResponse:  # noqa: E501
        """Gets a ComplianceRuleAssignment  # noqa: E501

        Gets a ComplianceRuleAssignment. If special character is provided as part of path parameter then it should be provided in url encoded form.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.compliance_rule_assignment_api_get_compliance_rule_assignment_with_http_info(vnd_com_blackrock_request_id, vnd_com_blackrock_origin_timestamp, id, async_req=True)
        >>> result = thread.get()

        :param vnd_com_blackrock_request_id: A unique identifier for this request. (required)
        :type vnd_com_blackrock_request_id: str
        :param vnd_com_blackrock_origin_timestamp: Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231. (required)
        :type vnd_com_blackrock_origin_timestamp: datetime
        :param id: Compliance rule assignment id (required)
        :type id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(V1ComplianceRuleAssignment, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'vnd_com_blackrock_request_id',
            'vnd_com_blackrock_origin_timestamp',
            'id'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method compliance_rule_assignment_api_get_compliance_rule_assignment" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['vnd_com_blackrock_request_id']:
            _header_params['VND.com.blackrock.Request-ID'] = _params['vnd_com_blackrock_request_id']

        if _params['vnd_com_blackrock_origin_timestamp']:
            _header_params['VND.com.blackrock.Origin-Timestamp'] = _params['vnd_com_blackrock_origin_timestamp']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['APIKeyHeader', 'OAuth2ClientCredentials', 'basicAuth', 'OAuth2AccessCode', 'ClientKeyHeader']  # noqa: E501

        _response_types_map = {
            '200': "V1ComplianceRuleAssignment",
            '400': "ComplianceRuleAssignmentAPICreateComplianceRuleAssignment400Response",
            '401': "ComplianceRuleAssignmentAPICreateComplianceRuleAssignment400Response",
            '403': "ComplianceRuleAssignmentAPICreateComplianceRuleAssignment400Response",
            '404': "ComplianceRuleAssignmentAPICreateComplianceRuleAssignment400Response",
        }

        return self.api_client.call_api(
            '/complianceRuleAssignments/{id}', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def compliance_rule_assignment_api_update_compliance_rule_assignment(self, vnd_com_blackrock_request_id : Annotated[StrictStr, Field(..., description="A unique identifier for this request.")], vnd_com_blackrock_origin_timestamp : Annotated[datetime, Field(..., description="Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231.")], compliance_rule_assignment_id : Annotated[StrictStr, Field(..., description="Rule Assignment ID")], body : Annotated[V1ComplianceRuleAssignment, Field(..., description="ComplianceRuleAssignment to update.")], update_mask : Annotated[Optional[StrictStr], Field(description="List of fields to be updated. Warning: Please ensure you understand the implications of using a field mask. And more precisely the fact you need all fields mentioned to be present in your payload. Also, portfolios and rules configurations are linked and cannot be updated separately. If you want to add either portfolios or rules configurations to your field mask, please ensure that you add portfolios and all rules configurations.")] = None, **kwargs) -> V1ComplianceRuleAssignment:  # noqa: E501
        """Update an existing ComplianceRuleAssignment  # noqa: E501

        IMPORTANT: Portfolios and rules configurations are linked and cannot therefore be updated separately. In order to publish a change on either portfolios or rule configurations, please ensure you provide all portfolios and rules configurations you want the system to retain. Throws NOT_FOUND when record does not exist  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.compliance_rule_assignment_api_update_compliance_rule_assignment(vnd_com_blackrock_request_id, vnd_com_blackrock_origin_timestamp, compliance_rule_assignment_id, body, update_mask, async_req=True)
        >>> result = thread.get()

        :param vnd_com_blackrock_request_id: A unique identifier for this request. (required)
        :type vnd_com_blackrock_request_id: str
        :param vnd_com_blackrock_origin_timestamp: Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231. (required)
        :type vnd_com_blackrock_origin_timestamp: datetime
        :param compliance_rule_assignment_id: Rule Assignment ID (required)
        :type compliance_rule_assignment_id: str
        :param body: ComplianceRuleAssignment to update. (required)
        :type body: V1ComplianceRuleAssignment
        :param update_mask: List of fields to be updated. Warning: Please ensure you understand the implications of using a field mask. And more precisely the fact you need all fields mentioned to be present in your payload. Also, portfolios and rules configurations are linked and cannot be updated separately. If you want to add either portfolios or rules configurations to your field mask, please ensure that you add portfolios and all rules configurations.
        :type update_mask: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: V1ComplianceRuleAssignment
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the compliance_rule_assignment_api_update_compliance_rule_assignment_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.compliance_rule_assignment_api_update_compliance_rule_assignment_with_http_info(vnd_com_blackrock_request_id, vnd_com_blackrock_origin_timestamp, compliance_rule_assignment_id, body, update_mask, **kwargs)  # noqa: E501

    @validate_arguments
    def compliance_rule_assignment_api_update_compliance_rule_assignment_with_http_info(self, vnd_com_blackrock_request_id : Annotated[StrictStr, Field(..., description="A unique identifier for this request.")], vnd_com_blackrock_origin_timestamp : Annotated[datetime, Field(..., description="Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231.")], compliance_rule_assignment_id : Annotated[StrictStr, Field(..., description="Rule Assignment ID")], body : Annotated[V1ComplianceRuleAssignment, Field(..., description="ComplianceRuleAssignment to update.")], update_mask : Annotated[Optional[StrictStr], Field(description="List of fields to be updated. Warning: Please ensure you understand the implications of using a field mask. And more precisely the fact you need all fields mentioned to be present in your payload. Also, portfolios and rules configurations are linked and cannot be updated separately. If you want to add either portfolios or rules configurations to your field mask, please ensure that you add portfolios and all rules configurations.")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Update an existing ComplianceRuleAssignment  # noqa: E501

        IMPORTANT: Portfolios and rules configurations are linked and cannot therefore be updated separately. In order to publish a change on either portfolios or rule configurations, please ensure you provide all portfolios and rules configurations you want the system to retain. Throws NOT_FOUND when record does not exist  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.compliance_rule_assignment_api_update_compliance_rule_assignment_with_http_info(vnd_com_blackrock_request_id, vnd_com_blackrock_origin_timestamp, compliance_rule_assignment_id, body, update_mask, async_req=True)
        >>> result = thread.get()

        :param vnd_com_blackrock_request_id: A unique identifier for this request. (required)
        :type vnd_com_blackrock_request_id: str
        :param vnd_com_blackrock_origin_timestamp: Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231. (required)
        :type vnd_com_blackrock_origin_timestamp: datetime
        :param compliance_rule_assignment_id: Rule Assignment ID (required)
        :type compliance_rule_assignment_id: str
        :param body: ComplianceRuleAssignment to update. (required)
        :type body: V1ComplianceRuleAssignment
        :param update_mask: List of fields to be updated. Warning: Please ensure you understand the implications of using a field mask. And more precisely the fact you need all fields mentioned to be present in your payload. Also, portfolios and rules configurations are linked and cannot be updated separately. If you want to add either portfolios or rules configurations to your field mask, please ensure that you add portfolios and all rules configurations.
        :type update_mask: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(V1ComplianceRuleAssignment, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'vnd_com_blackrock_request_id',
            'vnd_com_blackrock_origin_timestamp',
            'compliance_rule_assignment_id',
            'body',
            'update_mask'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method compliance_rule_assignment_api_update_compliance_rule_assignment" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['compliance_rule_assignment_id']:
            _path_params['complianceRuleAssignment.id'] = _params['compliance_rule_assignment_id']


        # process the query parameters
        _query_params = []
        if _params.get('update_mask') is not None:  # noqa: E501
            _query_params.append(('updateMask', _params['update_mask']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['vnd_com_blackrock_request_id']:
            _header_params['VND.com.blackrock.Request-ID'] = _params['vnd_com_blackrock_request_id']

        if _params['vnd_com_blackrock_origin_timestamp']:
            _header_params['VND.com.blackrock.Origin-Timestamp'] = _params['vnd_com_blackrock_origin_timestamp']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['body'] is not None:
            _body_params = _params['body']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['APIKeyHeader', 'OAuth2ClientCredentials', 'basicAuth', 'OAuth2AccessCode', 'ClientKeyHeader']  # noqa: E501

        _response_types_map = {
            '200': "V1ComplianceRuleAssignment",
            '400': "ComplianceRuleAssignmentAPICreateComplianceRuleAssignment400Response",
            '401': "ComplianceRuleAssignmentAPICreateComplianceRuleAssignment400Response",
            '403': "ComplianceRuleAssignmentAPICreateComplianceRuleAssignment400Response",
            '404': "ComplianceRuleAssignmentAPICreateComplianceRuleAssignment400Response",
        }

        return self.api_client.call_api(
            '/complianceRuleAssignments/{complianceRuleAssignment.id}', 'PATCH',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
